#ifndef ___INCLUDES_H__
#define ___INCLUDES_H__
/*
 * Nessus system includes 
 */

#ifndef USE_PTHREADS
# undef HAVE_INET_NETA
# undef HAVE_ADDR2ASCII
#endif

//#include <unistd.h>

#ifdef linux
/* avoid symbol clash with librpcsvc.a(xmount.o) */
#define xdr_fhstatus xDr_fHsTaTuS
#endif

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <memory.h>
# include <string.h>                                                    
#include <strings.h>
//#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <sys/un.h>
#include <arpa/inet.h>
#include <signal.h>
#include <dlfcn.h>
#include <sys/wait.h>                                                

#ifndef WEXITSTATUS
#define WEXITSTATUS(stat_val) ((unsigned)(stat_val) >> 8)               
#endif                                                                
#ifndef WIFEXITED                                                        
#define WIFEXITED(stat_val) (((stat_val) & 255) == 0)                 
#endif    

#include <sys/time.h>                                                
#include <time.h>                                               
#include <sys/stat.h>
#include <sys/param.h>
# include <dirent.h>
# define NAMLEN(dirent) strlen((dirent)->d_name)                 

#  include <sys/dir.h>                                                
#include <pwd.h>
#include <termios.h>
#include <pty.h>

#ifdef HAVE_VALUES_H

/*
 * Most systems re-define MAXINT in values.h, so we avoid a naughty
 * warning
 */
#ifdef MAXINT
#define ___OLD_MAXINT MAXINT
#undef MAXINT
#endif

#include <values.h>

#ifndef MAXINT
#define MAXINT ___OLD_MAXINT
#endif
#endif

#include <limits.h>

#include <openssl/ssl.h>
//#include <openssl/ocsp.h>

/*
 * Threads management
 *
 * Nessus is currently able to deal with 
 * 3 kinds of threads API :
 *
 * - the POSIX Threads
 * - the WindowsNT Threads
 * - fork() used as Threads
 *
 */

#ifdef NESSUSNT
# define USE_NT_THREADS
#else
# ifndef USE_PTHREADS
#  define USE_FORK_THREADS
# endif
#endif

#ifdef USE_PTHREADS
# ifdef HAVE_PTHREAD_H
#  include <pthread.h>
# else
#  error "Your system is lacking pthread support"
# endif
#endif

#include <sys/mman.h>
#include <alloca.h>

#ifdef BSD_BYTE_ORDERING
# define FIX(n) (n)
# define UNFIX(n) (n)
#else
# define FIX(n) htons(n)
# define UNFIX(n) ntohs(n)
#endif

#include <pcap.h>
#include <nessus/ntcompat.h>
#include <nessus/harglists.h>
#include <nessus/libnessus.h>
#include <nessus/nessus-devel.h>

#ifdef HAVE_SHL_LOAD	/* I love HPUX (jh) */
# undef dlopen
# undef dlsym
# undef dlclose
# undef dlerror
#endif /* HAVE_SHL_LOAD */


#ifndef MAP_FAILED
#define MAP_FAILED (void*)(-1)
#endif

#endif /* not defined(___INCLUDES_H) */
