/* 
 * Copyright (C) 2003 Star Chamber Inc.
 *
 * Sussen - sussen-getting-started-druid.c
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Loren Bandiera <lorenb@starchamber.ca>
 */
 
 #include "sussen.h"
 #include "sussen-fileio.h"
 #include "sussen-gconf.h"
 #include "sussen-util.h"
 #include "sussen-getting-started-druid.h"
 
 /*
 * FIXME: Seems to be a bug in libglade, the druid doesn't display the
 *        start and end pages.  Had to 'build source' from glade2 to make 
 *		  it work.  Odd that it works when building from source but not loading
 *		  from xml.
 */

GtkWidget *druid;

GtkWidget* create_sussen_getting_started_druid_dialog (void) {
	
	GtkWidget *sussen_getting_started_druid_dialog;
	GtkWidget *dialog_vbox1;
	GtkWidget *sussen_getting_started_druid;
	GtkWidget *start_page;
	GtkWidget *page1;
	GtkWidget *druid_vbox1;
	GtkWidget *fixed1;
	GtkWidget *nessusd_entry;
	GtkWidget *label1;
	GtkObject *port_spin_button_adj;
	GtkWidget *port_spin_button;
	GtkWidget *label2;
	GtkWidget *nessusd_username_entry;
	GtkWidget *label3;
	GtkWidget *end_page;
	GtkWidget *dialog_action_area1;
	
	sussen_getting_started_druid_dialog = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (sussen_getting_started_druid_dialog), _("Getting Started"));

	dialog_vbox1 = GTK_DIALOG (sussen_getting_started_druid_dialog)->vbox;
	gtk_widget_show (dialog_vbox1);
	
	sussen_getting_started_druid = gnome_druid_new ();
	gtk_widget_show (sussen_getting_started_druid);
	gtk_box_pack_start (GTK_BOX (dialog_vbox1), sussen_getting_started_druid, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (sussen_getting_started_druid), 4);
	
	start_page = gnome_druid_page_edge_new (GNOME_EDGE_START);
	gtk_widget_show (start_page);
	gnome_druid_append_page (GNOME_DRUID (sussen_getting_started_druid),
							GNOME_DRUID_PAGE (start_page));
	gnome_druid_page_edge_set_title (GNOME_DRUID_PAGE_EDGE (start_page),
									_("Getting Started"));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (start_page),
									_("This is the first time you have run Sussen.  The program will need to collect some information from you.  Click 'Forward' to proceed.\n"));

	page1 = gnome_druid_page_standard_new ();
	gtk_widget_show_all (page1);
	gnome_druid_append_page (GNOME_DRUID (sussen_getting_started_druid),
	GNOME_DRUID_PAGE (page1));
	gnome_druid_page_standard_set_title (GNOME_DRUID_PAGE_STANDARD (page1), _("Nessus Server Information"));

	druid_vbox1 = GNOME_DRUID_PAGE_STANDARD (page1)->vbox;
	gtk_widget_show (druid_vbox1);
	gtk_container_set_border_width (GTK_CONTAINER (druid_vbox1), 16);

	fixed1 = gtk_fixed_new ();
	gtk_widget_show (fixed1);
	gtk_box_pack_start (GTK_BOX (druid_vbox1), fixed1, TRUE, TRUE, 0);

	nessusd_entry = gtk_entry_new ();
	gtk_widget_show (nessusd_entry);
	gtk_fixed_put (GTK_FIXED (fixed1), nessusd_entry, 144, 16);
	gtk_widget_set_size_request (nessusd_entry, 268, 25);

	label1 = gtk_label_new (_("Server Hostname:"));
	gtk_widget_show (label1);
	gtk_fixed_put (GTK_FIXED (fixed1), label1, 8, 16);
	gtk_widget_set_size_request (label1, 140, 22);
	gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);

	port_spin_button_adj = gtk_adjustment_new (1, 0, 65534, 1, 10, 10);
	port_spin_button = gtk_spin_button_new (GTK_ADJUSTMENT (port_spin_button_adj), 1, 0);
	gtk_widget_show (port_spin_button);
	gtk_fixed_put (GTK_FIXED (fixed1), port_spin_button, 144, 56);
	gtk_widget_set_size_request (port_spin_button, 72, 25);

	label2 = gtk_label_new (_("Server Port:"));
	gtk_widget_show (label2);
	gtk_fixed_put (GTK_FIXED (fixed1), label2, 40, 56);
	gtk_widget_set_size_request (label2, 99, 22);
	gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);

	nessusd_username_entry = gtk_entry_new ();
	gtk_widget_show (nessusd_username_entry);
	gtk_fixed_put (GTK_FIXED (fixed1), nessusd_username_entry, 144, 128);
	gtk_widget_set_size_request (nessusd_username_entry, 158, 25);

	label3 = gtk_label_new (_("Username:"));
	gtk_widget_show (label3);
	gtk_fixed_put (GTK_FIXED (fixed1), label3, 56, 128);
	gtk_widget_set_size_request (label3, 82, 22);
	gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);

	end_page = gnome_druid_page_edge_new (GNOME_EDGE_FINISH);
	gtk_widget_show (end_page);
	gnome_druid_append_page (GNOME_DRUID (sussen_getting_started_druid),
	GNOME_DRUID_PAGE (end_page));
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (end_page),
									_("Sussen has the necessary information to proceed.  Click 'Apply' to start using Sussen."));

	dialog_action_area1 = GTK_DIALOG (sussen_getting_started_druid_dialog)->action_area;
	gtk_widget_show (dialog_action_area1);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF (sussen_getting_started_druid_dialog, sussen_getting_started_druid_dialog, "sussen_getting_started_druid_dialog");
	GLADE_HOOKUP_OBJECT_NO_REF (sussen_getting_started_druid_dialog, dialog_vbox1, "dialog_vbox1");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, sussen_getting_started_druid, "sussen_getting_started_druid");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, start_page, "start_page");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, page1, "page1");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, druid_vbox1, "druid_vbox1");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, fixed1, "fixed1");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, nessusd_entry, "nessusd_entry");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, label1, "label1");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, port_spin_button, "port_spin_button");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, label2, "label2");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, nessusd_username_entry, "nessusd_username_entry");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, label3, "label3");
	GLADE_HOOKUP_OBJECT (sussen_getting_started_druid_dialog, end_page, "end_page");
	GLADE_HOOKUP_OBJECT_NO_REF (sussen_getting_started_druid_dialog, dialog_action_area1, "dialog_action_area1");

	return sussen_getting_started_druid_dialog;	
}

void set_sussen_preferences (GnomeDruidPage *druidpage, GtkWidget *widget, gpointer user_data) {
	
	GtkWidget *last_page;
	GtkWidget *the_druid;
	GtkWidget *w;
	const gchar *hostname;
	const gchar *username;
	gint port;
	gchar *tmp;
	GSList *list = NULL;
	
	the_druid = lookup_widget (druid,"sussen_getting_started_druid");
	last_page = lookup_widget (druid,"end_page");
	
	w = lookup_widget (druid,"nessusd_entry");
	hostname = gtk_entry_get_text (GTK_ENTRY(w));
	
	w = lookup_widget (druid, "port_spin_button");
	port = (gint)gtk_spin_button_get_value (GTK_SPIN_BUTTON(w));
	
	w = lookup_widget (druid,"nessusd_username_entry");
	username = gtk_entry_get_text (GTK_ENTRY(w));

	tmp = g_malloc (255);
	g_snprintf (tmp,255,"%s:%d:%s:1",hostname,port,username);
	list = g_slist_append (list, g_strdup(tmp));
	set_server_xml (g_slist_copy(list));

	g_free (tmp);
	
	gnome_druid_set_page (GNOME_DRUID(the_druid),GNOME_DRUID_PAGE (last_page));
}

void finish_getting_started_druid (GnomeDruidPage *druidpage, GtkWidget *widget, gpointer user_data) {

	gtk_widget_destroy (druid);
	gtk_main_quit ();
}

void show_getting_started_druid (void) {
	
	GtkWidget *w;
	
	druid = create_sussen_getting_started_druid_dialog ();
	gtk_widget_show (druid);

	w = lookup_widget (druid, "sussen_getting_started_druid");
	g_signal_connect_swapped (GTK_OBJECT (w),
							  "cancel",
							  G_CALLBACK (gtk_widget_destroy),
							  (gpointer) druid);	
	
	w = lookup_widget (druid, "page1");
	g_signal_connect (GTK_OBJECT (w),
					  "next",
					  G_CALLBACK (set_sussen_preferences),
					  NULL);	

	w = lookup_widget (druid, "end_page");
	g_signal_connect (GTK_OBJECT (w),
					  "finish",
					  G_CALLBACK (finish_getting_started_druid),
					  NULL);
	
	w = lookup_widget (druid, "port_spin_button");
	gtk_spin_button_set_value (GTK_SPIN_BUTTON(w),1241);
	
	gtk_main ();
}
