/* 
 * Copyright (C) 2003 Star Chamber Inc.
 *
 * Sussen - sussen.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Loren Bandiera <lorenb@starchamber.ca>
 */

#ifndef __SUSSEN_H
#define __SUSSEN_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* Be clean and pure */
#define GTK_DISABLE_DEPRECATED
#define G_DISABLE_DEPRECATED

#include <gnome.h>
#include <glib.h>
#include <glade/glade.h>
#include <gconf/gconf-client.h>
#include <pthread.h>
#include <openssl/ssl.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

/* Sussen globals */


extern GtkWidget *main_window;
extern GConfClient *client;

extern GladeXML *mainwindow_xml;
extern GladeXML *preferences_xml;
extern GladeXML *kb_dialog;
extern GladeXML *policy_manager;
extern GladeXML *report_xml;

extern GtkWidget *nessusd_tree;
extern GtkListStore *nessusd_store;

extern GtkWidget *plug_family_tree;
extern GtkListStore *plug_family_store;

extern GtkWidget *plug_tree;
extern GtkListStore *plug_store;

extern GtkWidget *targets_tree;
extern GtkListStore *targets_store;

extern GtkWidget *session_tree;
extern GtkListStore *session_store;

extern GtkWidget *scan_status_tree;
extern GtkListStore *scan_status_store;

extern GtkTreeModel *global_model;
extern GtkTreeIter *global_iter;

extern GtkWidget *plug_pref_tree;
extern GtkListStore *plug_pref_store;
extern GtkWidget *plugin_description_textview;

extern gint global_tag;
extern gint global_backend;
extern gint global_flag;

extern gint use_policy_file;
extern GHashTable *plugin_hash;

void load_gnome_frontend (void);

#endif
